package ink.wgink.module.wechat.service.pay;

import ink.wgink.common.base.DefaultBaseService;
import ink.wgink.exceptions.PropertiesException;
import ink.wgink.properties.wechat.pay.v3.PayProperties;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @ClassName: BasePayService
 * @Description: 基础支付业务
 * @Author: wanggeng
 * @Date: 2021/8/24 11:02 上午
 * @Version: 1.0
 */
public class BasePayService extends DefaultBaseService {

    public static final String PAY_BASE_URL = "https://api.mch.weixin.qq.com";
    public static final String PAY_SANDBOXNEW = "sandboxnew";

    @Autowired
    protected PayProperties payProperties;

    protected String getPayBaseUrl() {
        if (!payProperties.getActive()) {
            throw new PropertiesException("微信支付未激活");
        }
        if (!payProperties.getProduce()) {
            // 沙河环境
            return PAY_BASE_URL + "/" + PAY_SANDBOXNEW;
        }
        return PAY_BASE_URL;
    }

}
